/* 
 * MyIp Trigger plugin for HeXHub (http://sourceforge.net/projects/hexhub)
 * (C) Copyright 2007 Morten Larsen, bluebear dot dk at gmail dot com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <windows.h>
#include "hexhub.h"

long trigId, hlpId, ucId;

void HEXHUBAPI onCmd(long cid, long uid, void *r, void *cp, bool b) {
	char botnick[MAX_NICK];
	char usernick[MAX_NICK];
	char userip[MAX_IP];
	char buf[MAX_NICK+MAX_NICK+MAX_NICK+MAX_IP+39];
	int len;

	if (HexHubFunctions::ClientNickFromId(HUBBOT_ID, botnick) == false) return;
	if (HexHubFunctions::GetIPString(uid, userip) < 1) return;

	if (b == true) {
		if (HexHubFunctions::ClientNickFromId(uid, usernick) == false) return;
		len = wsprintfA(buf, "$To: %s From: %s $<%s> Your current IP is: %s|", usernick, botnick, botnick, userip);
	} else len = wsprintfA(buf, "<%s> Your current IP is: %s|", botnick, userip);

	HexHubFunctions::SendTo(uid, buf, len);
}

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHubFunctions hhf;
	if (hhf.Init(HexGetFunction) == false) return 0;

	if ((trigId = HexHubFunctions::RegisterCommand("myip", onCmd)) == -1) return 0;
	
	if ((hlpId = HexHubFunctions::RegisterHelpString("EN", "!myip\t\t\t-\tDisplays you current ip address", 0)) == -1) {
		HexHubFunctions::UnregisterCommand(trigId);
		return 0;
	}

	if ((ucId = HexHubFunctions::RegisterUserCommand("$UserCommand 1 1 Shows your IP$<%[mynick]> !myip&#124;|")) == -1) {
		HexHubFunctions::UnregisterCommand(trigId);
		HexHubFunctions::UnregisterHelpString(hlpId);
		return 0;
	}

	return "myip trigger 0.1 by bluebear";
}

void HEXHUBAPI UnloadPlugin(void) {
	HexHubFunctions::UnregisterCommand(trigId);
	HexHubFunctions::UnregisterHelpString(hlpId);
	HexHubFunctions::UnregisterUserCommand(ucId);
}
